SystemOrganization addCategory: #'SourceCity-Importer'!

Object subclass: #CityImporter
	instanceVariableNames: 'city districts buildings widthSelector heightSelector id lowColor mediumColor highColor mediumColorValue highColorValue buildingsPicking'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!CityImporter commentStamp: '<historical>' prior: 0!
I'm responsible for populating a city from a model (usually a ring model)!

!CityImporter class methodsFor: 'default-model' stamp: 'StephaneDucasse 5/14/2012 11:44'!
defaultModel
	
	^ self new 
	cityNamed: 'CodCT' withPackageNames: RPackageOrganizer default packageNames.! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 6/5/2012 13:23'!
basicBuilding: aClassName district: aDistrict
	| tmp |
	id := id +1.
	tmp :=  Building forClass: aClassName inDistrict: aDistrict widthSelector: self widthSelector heightSelector: self heightSelector id: (id) colorMediumSelector: self mediumColorValue colorHighSelector: self highColorValue colorLow: self lowColor colorHigh: self highColor.
	buildingsPicking at: id put: tmp.
	^tmp.! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
basicDistrict: aPackageName city: aCity
	
	^  District forPackage: (self packageNamed: aPackageName) inCity: aCity.
	
	! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:25'!
buildings
	^ buildings! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:25'!
buildings: anObject
	buildings := anObject! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/23/2012 11:03'!
buildingsPicking
	^ buildingsPicking! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/23/2012 11:03'!
buildingsPicking: anObject
	buildingsPicking := anObject! !

!CityImporter methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 11:44'!
city
	^city! !

!CityImporter methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 11:44'!
city: aCity
	city := aCity! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 5/22/2012 15:33'!
cityNamed: aName withPackageNames: aCol 

	self cityNamed: aName withPackageNames: aCol widthSelectorChoice: #'yourself' heightSelectorChoice: #'yourself'! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 5/22/2012 16:33'!
cityNamed: aName withPackageNames: aCol widthSelectorChoice: aSelectorw heightSelectorChoice: aSelectorh

	self cityNamed: aName withPackageNames: aCol widthSelectorChoice: aSelectorw heightSelectorChoice: aSelectorh colorMediumSelector: 20 colorHighSelector: 50 colorLow: (Color blue) colorMedium: (Color green)  colorHigh: (Color red) ! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 5/22/2012 15:43'!
cityNamed: aName withPackageNames: aCol widthSelectorChoice: aSelectorw heightSelectorChoice: aSelectorh colorMediumSelector: mediumValue colorHighSelector: highValue colorLow: aLowColor colorMedium: aMediumColor colorHigh: aHighColor


	self city: (City model: aName).
	self heightSelector: aSelectorh.
	self widthSelector: aSelectorw.
	self lowColor: aLowColor.
	self mediumColor: aMediumColor.
	self highColor: aHighColor.
	self mediumColorValue: mediumValue.
	self highColorValue: highValue.
	aCol do: [:each | self importPackageAsDistrict: each ].
	self importClassAsBuilding .! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:25'!
districts
	^ districts! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:25'!
districts: anObject
	districts := anObject! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
ensureBuilding: aClassName district: aDistrict
	^ buildings
			at: aClassName 
			ifAbsentPut: [ self basicBuilding: aClassName district: aDistrict].
			
						! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
ensureDistrict: aPackageName
	^districts 
			at: aPackageName 
			ifAbsentPut: [ self basicDistrict: aPackageName city: (self city)].
			
						! !

!CityImporter methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 11:44'!
heightSelector
	^ heightSelector! !

!CityImporter methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 11:44'!
heightSelector: anObject
	heightSelector := anObject! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:27'!
highColor
	^ highColor! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:27'!
highColor: anObject
	highColor := anObject! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:27'!
highColorValue
	^ highColorValue! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:27'!
highColorValue: anObject
	highColorValue := anObject! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:25'!
id
	^ id! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:25'!
id: anObject
	id := anObject! !

!CityImporter methodsFor: 'import' stamp: 'DouailleErwan 5/30/2012 10:38'!
importClassAsBuilding
	(self city districts) do: [ :each |
		(each model classes) do: [ :eachClass |
			eachClass isBehavior
				ifTrue: [ self importClassAsBuilding: eachClass district: each ]]
			displayingProgress: 'importing classes'.
		].! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
importClassAsBuilding: aClassName district: aDistrict
	
	self ensureBuilding: aClassName district: aDistrict.
	! !

!CityImporter methodsFor: 'import' stamp: 'StephaneDucasse 5/14/2012 11:44'!
importPackageAsDistrict: aPackageName
	
	self ensureDistrict: aPackageName.
	! !

!CityImporter methodsFor: 'initialize-release' stamp: 'DouailleErwan 5/23/2012 10:41'!
initialize
	super initialize.
	id := 0.
	districts := Dictionary new.
	buildings := Dictionary new.
	buildingsPicking := Dictionary new.! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:27'!
lowColor
	^ lowColor! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:27'!
lowColor: anObject
	lowColor := anObject! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:27'!
mediumColor
	^ mediumColor! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:27'!
mediumColor: anObject
	mediumColor := anObject! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:27'!
mediumColorValue
	^ mediumColorValue! !

!CityImporter methodsFor: 'accessing' stamp: 'DouailleErwan 5/22/2012 15:27'!
mediumColorValue: anObject
	mediumColorValue := anObject! !

!CityImporter methodsFor: 'utils' stamp: 'StephaneDucasse 5/14/2012 11:44'!
numberOfBuilding

	^ city districts inject: 0 into: [:sum :each | sum + each buildings size.].
! !

!CityImporter methodsFor: 'utils' stamp: 'StephaneDucasse 5/14/2012 11:44'!
numberOfDistrict
	^city districts size! !

!CityImporter methodsFor: 'utils' stamp: 'DouailleErwan 5/29/2012 16:10'!
packageNamed: aString
	^ RPackageOrganizer default packageNamed: aString! !

!CityImporter methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 14:18'!
widthSelector
	^ widthSelector! !

!CityImporter methodsFor: 'accessing' stamp: 'StephaneDucasse 5/14/2012 14:18'!
widthSelector: anObject
	widthSelector := anObject! !

CityImporter subclass: #CityMultiImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!CityMultiImporter commentStamp: '<historical>' prior: 0!
Similary to CityImporer but without RPackageOrganizer!

!CityMultiImporter methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/29/2012 15:00'!
cityNamed: aName withPackageNames: aCol withClassSelector: aClassSelector

	self cityNamed: aName withPackageNames: aCol withClassSelector: aClassSelector widthSelectorChoice: #'yourself' heightSelectorChoice: #'yourself'! !

!CityMultiImporter methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/29/2012 15:00'!
cityNamed: aName withPackageNames: aCol withClassSelector: aClassSelector widthSelectorChoice: aSelectorw heightSelectorChoice: aSelectorh

	self cityNamed: aName withPackageNames: aCol withClassSelector: aClassSelector widthSelectorChoice: aSelectorw heightSelectorChoice: aSelectorh colorMediumSelector: 20 colorHighSelector: 50 colorLow: (Color blue) colorMedium: (Color green)  colorHigh: (Color red) ! !

!CityMultiImporter methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 5/29/2012 13:19'!
cityNamed: aName withPackageNames: aCol withClassSelector: aClassSelector widthSelectorChoice: aSelectorw heightSelectorChoice: aSelectorh colorMediumSelector: mediumValue colorHighSelector: highValue colorLow: aLowColor colorMedium: aMediumColor colorHigh: aHighColor


	self city: (City model: aName).
	self heightSelector: aSelectorh.
	self widthSelector: aSelectorw.
	self lowColor: aLowColor.
	self mediumColor: aMediumColor.
	self highColor: aHighColor.
	self mediumColorValue: mediumValue.
	self highColorValue: highValue.
	aCol do: [:each | self importPackageAsDistrict: each ].
	self importClassAsBuilding: aClassSelector .! !

!CityMultiImporter methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/4/2012 15:29'!
importClassAsBuilding: aClassSelector
	(self city districts) do: [ :each |
		(each model perform: aClassSelector) do: [ :eachClass |
			eachClass isBehavior
				ifTrue: [ self importClassAsBuilding: eachClass district: each ]]
			displayingProgress: 'importing classes'.
		].
	"yo"! !

!CityMultiImporter methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/4/2012 12:01'!
packageNamed: aString
	^ aString! !

TestCase subclass: #CityImporterTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Importer'!

!CityImporterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/14/2012 11:45'!
testDisplayFullyImportOfRing
	"self debug: #testFullyImportOfRing"
	
	| cimport build height |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: (RPackageOrganizer default packageNames).
	build := 0.
	height := 0.
	(cimport city districts) do:[:each|
		(each buildings) do:[:eachClass|
			build := build+1.
			].
		].
	Transcript clear;show:'1 ville - ';show:cimport city districts size;show: ' districts - ';show: build;show:' buildings le plus haut fait : ';show:height.! !

!CityImporterTest methodsFor: 'tests' stamp: 'DouailleErwan 5/29/2012 13:39'!
testFullyImportOfRing
	"self debug: #testFullyImportOfRing"
	"This method test, is just for show us what does normal import realize. How many build, districts ... and max metrics we can find"
	| cimport ring build height |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: (RPackageOrganizer default packageNames).
	
	"self assert: cimport city districts size = 481.
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city hasDistrictNamed: #'SourceCity')."
	"Transcript cr;show:cimport city size."
	build := 0.
	height := 0.
	(cimport city districts) do:[:each|
		(each buildings) do:[:eachClass|
			build := build+1.
			].
		].
	Transcript clear;show:'1 ville - ';show:cimport city districts size;show: ' districts - ';show: build;show:' buildings le plus haut fait : ';show:height.
	"Transcript cr;show: (RPackage new numberOfClasses)."! !

!CityImporterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/14/2012 11:45'!
testImportClassAsBuilding
	"self debug: #testImportClassAsBuilding"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	self assert: (cimport city districts at: 1)buildings size = cimport numberOfBuilding.
	
	! !

!CityImporterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/14/2012 11:45'!
testImportPackageAsDistrict
	"self debug: #testImportPackageAsDistrict"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core' ).
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	! !

!CityImporterTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/14/2012 11:45'!
testImportPackageAsDistrictNoDuplicate
	"self debug: #testImportPackageAsDistrictNoDuplicate"
	
	| cimport |
	cimport := CityImporter new.
	cimport cityNamed: 'CodCT' withPackageNames: #('AST-Core'  'AST-Core').
	self assert: cimport city districts size = cimport numberOfDistrict .
	self assert: (cimport city hasDistrictNamed: #'AST-Core').
	! !
